import { feature } from 'topojson';
import { json, tsv} from 'd3';
export const loadAndProcessData = () => 
  Promise.all([
    tsv("https://cdn.jsdelivr.net/npm/world-atlas@1.1.4/world/50m.tsv"),
    json("https://cdn.jsdelivr.net/npm/world-atlas@1.1.4/world/50m.json")
  ])
    .then(([tsvData, topoJSONData]) => {
      const rowById = tsvData.reduce((acc, d) => {
        acc[d.iso_n3] = d;
        return acc
      }, {});
      const countries = feature(topoJSONData, topoJSONData.objects.countries);
      countries.features.forEach(d => Object.assign(d.properties, rowById[d.id]));
      return countries
  	});
